/**

========[DmineurC]
========[r_1.0]

Code source produit par M-ye** Lan-yr.. a.k.a. Pontilvien

( C'est un chouette dmineur. Si il y a un 'C'  la fin, c'est parce qu'en fait, et ben c'est un programme en C.
Le hasard fait bien les choses, n'est-il pas ? )

Petit bouts de truc utiliss :
	- MonoChr0meLib.h par PierrotLL
	- usefull.h par Dodormeur
	- getkey.src, et memory.h par LePhenixNoir
	- Et c'est tout... pour le moment !

Aussi, qui que vous soyez, merci de bien vouloir vous dsabonner de T-Series et de vous abonner  PewDiePie

**/


#include "fxlib.h"
#include "stdlib.h"
#include "MonochromeLib.h"
#include "usefull.h"
#include "display.h"
#include "gameplay.h"
#include "memory.h"




int launch(int new);

void credits();



int AddIn_main(int isAppli, unsigned short OptionNum){ // L dedans, j'ai mis le menu principal

	unsigned int key;
	int continuerPossible;
	int choix;
	int ret;

	const unsigned char DemineurC[81] = {
		0xF8, 0xFE, 0xC6, 0xF6, 0x37, 0xF6, 0x37, 0xE0, 0xF8, 
		0xCC, 0xC6, 0xC6, 0x66, 0x36, 0x36, 0x36, 0x31, 0x8C, 
		0xC6, 0xC0, 0xEE, 0x66, 0x36, 0x06, 0x36, 0x31, 0x8C, 
		0xC6, 0xC0, 0xD6, 0x67, 0x36, 0x06, 0x36, 0x31, 0x80,
		0xC6, 0xF8, 0xC6, 0x66, 0xB7, 0xC6, 0x37, 0xE5, 0x80,
		0xC6, 0xC0, 0xC6, 0x66, 0x76, 0x06, 0x36, 0x31, 0x80,
		0xC6, 0xC0, 0xC6, 0x66, 0x36, 0x06, 0x36, 0x31, 0x8C,
		0xCC, 0xC6, 0xC6, 0x66, 0x36, 0x36, 0x36, 0x31, 0x8C,
		0xF8, 0xFE, 0xC6, 0xF6, 0x37, 0xF3, 0xE6, 0x30, 0xF8};

	const unsigned char droite[44] = { 227, 199, 135, 192, 121, 159, 241, 64, 28, 56, 124, 192, 70, 99, 14, 64, 51,
		207, 227, 0, 25, 152, 57, 128, 51, 207, 227, 0, 70, 99, 14, 64, 28, 56, 124,
		192, 121, 159, 241, 64, 227, 199, 135, 192 };

	const unsigned char gauche[44] = { 248, 120, 241, 192, 163, 254, 103, 128, 207, 135, 14, 0, 156, 49, 152, 128,
		49, 252, 243, 0, 103, 6, 102, 0, 49, 252, 243, 0, 156, 49, 152, 128, 207, 135,
		14, 0, 163, 254, 103, 128, 248, 120, 241, 192 };



	do{
		
		continuerPossible = (memory_exists("\\\\fls0\\DeminrC\\map.sav") && memory_exists("\\\\fls0\\DeminrC\\info.sav"));
		choix = 1 - continuerPossible;

		ML_rectangle(0, 0, 127, 63, 1, ML_BLACK, ML_WHITE);
		ML_rectangle(2, 14, 125, 61, 0, ML_BLACK, ML_BLACK);

		ML_bmp_xor(DemineurC, 29, 3, 70, 9);
		ML_bmp_xor(gauche, 2, 2, 26, 11);
		ML_bmp_xor(droite, 100, 2, 26, 11);

		PrintMini(55, 25, "CONTINUER", 2);
		PrintMini(65, 34, "NOUVEAU", 2);
		PrintMini(67, 43, "CREDITS", 2);
		PrintMini(65, 52, "QUITTER", 2);

		if(!continuerPossible) ML_horizontal_line(27, 54, 94, ML_WHITE);

		PrintMini(114, 56, "1.0", 2);
	
		do{
			if(key==0x0209 && choix && (choix>1 || continuerPossible)) choix--;
			if(key==0x0308 && choix<3) choix++;

			disp_Highlight(97, 24+9*choix);	
			
			key = getkey();
			
		}while(key!=0x0302);

		ret=0;	

		if(choix==2) credits();

		if(choix<2) ret = launch(choix);
		if(ret==-2) continuerPossible = 1;
		if(ret<-2) continuerPossible = 0;

	}while(choix<3 && ret!=-1);

	disp_Pontilev(15);
	
    return 1;}













int launch(int new){ // Fonction destine  'lancer' la partie : Choix du mode de jeu si nouveau, chargement de la save si continuer, puis gestion des sauvegardes
	
	const unsigned char difficulte[81] = {
		0xF9, 0xEF, 0xDF, 0x79, 0xE6, 0x6C, 0x3F, 0x7E, 0x00,
		0xCC, 0xCC, 0xD9, 0x33, 0x36, 0x6C, 0x0C, 0x66, 0x60,
		0xCC, 0xCC, 0x18, 0x33, 0x36, 0x6C, 0x0C, 0x60, 0x60,
		0xCC, 0xCC, 0x18, 0x33, 0x06, 0x6C, 0x0C, 0x60, 0x00,
		0xCC, 0xCF, 0x1E, 0x33, 0x06, 0x6C, 0x0C, 0x78, 0x00,
		0xCC, 0xCC, 0x18, 0x33, 0x06, 0x6C, 0x0C, 0x60, 0x60,
		0xCC, 0xCC, 0x18, 0x33, 0x36, 0x6C, 0x0C, 0x60, 0x60,
		0xCC, 0xCC, 0x18, 0x33, 0x36, 0x6C, 0x0C, 0x66, 0x00,
		0xF9, 0xEC, 0x18, 0x79, 0xE3, 0xCF, 0xCC, 0x7E, 0x00};


	const unsigned char custom[77] = {
		120, 243, 231, 239, 193, 230, 103, 159, 158, 102,   0,
		205, 155,  49, 140,   3,  54, 108, 198,  51, 126, 192,
		205, 155,  49, 140,   3,  54, 108,   6,  51, 126, 192,
		193, 251, 225, 143, 131,   6, 111, 198,  51, 102,   0,
		205, 155,  49, 140,   3,  54,  96, 198,  51, 102, 192,
		205, 155,  49, 140,   3,  54, 108, 198,  51, 102, 192,
		121, 155,  49, 143, 193, 227, 199, 134,  30, 102,   0};

	const unsigned char plusMoins[7] = { 32, 80, 136, 0, 136, 80, 32 };


	const unsigned char index[4] = {1, 2, 3, 0}; // Pas un bmp


	unsigned char* map = NULL;
	int* info = NULL;

	unsigned short indice;

	unsigned int key = 0;
	int ret = 0;

	int choix1 = 1;
	int choix2 = 2;
	int choix3 = 0;

	if(new){ // _________________________ Slection des paramtres de la nouvelle partie
		
		info = calloc(6, 4);
		if(!info) return 0;
		
		

		do{

			if(key==0x0209 && choix1) choix1--;
			if(key==0x0308 && choix1<4) choix1++;


			ML_rectangle(0, 0, 127, 63, 1, ML_BLACK, ML_WHITE);
			ML_rectangle(2, 2, 125, 61, 0, ML_BLACK, ML_BLACK);
	
			ML_bmp_xor(difficulte, 3, 3, 67, 9);
	
			PrintMini(4, 17, "< RETOUR", 2);
	
			PrintMini(71, 28, "FACILE", 2);
			PrintMini(71, 36, "MOYEN", 2);
			PrintMini(71, 44, "GALERE", 2);
			PrintMini(69, 52, "CUSTOM", 2);




			if(choix1) disp_Highlight(97, 19+8*choix1);
			else{
				ML_rectangle(3, 16, 35, 22, 0, ML_XOR, ML_XOR);
				ML_display_vram();
				ML_rectangle(3, 16, 35, 22, 0, ML_XOR, ML_XOR);}
			
			key = getkey();



			//_____________________________________________________________________________ Section custom




			if(key==0x0302 && choix1==4){ // Choix2 / 0=retour difficult / 1=Lancer / etc...
			
				ML_rectangle(0, 0, 127, 63, 1, ML_BLACK, ML_WHITE);
				ML_rectangle(2, 2, 125, 61, 0, ML_BLACK, ML_BLACK);
			
				ML_bmp_xor(custom, 3, 3, 82, 7);
			
				PrintMini(4, 15, "< RETOUR", 2);

				PrintMini(91, 15, "LANCER >", 2);
			
				PrintMini(50, 27, "HAUTEUR", 2);
				PrintMini(50, 35, "LARGEUR", 2);
				PrintMini(54, 43, "MINES", 2);
				PrintMini(44, 51, "T LIMITE", 2);
					
			
				do{
						
					if(key==0x0209 && choix2>1 && !choix3) choix2--;
					if(key==0x0308 && choix2<5 && choix2>1 && !choix3) choix2++;

					if(key==0x0309 && !choix2) choix2 = 1;
					if(key==0x0208 && choix2==1) choix2 = 0;

					if(key==0x0308 && choix2<2) choix2 = 2;

					if(key==0x0208 && choix2>1) choix3 = 1;
					if(key==0x0309) choix3 = 0;

					if(key==0x0209 && choix2>1 && choix3) info[index[choix2-2]]++;
					if(key==0x0308 && choix2>1 && choix3 && info[index[choix2-2]]) info[index[choix2-2]]--;




					ML_rectangle(81, 26, 125, 61, 0, ML_BLACK, ML_BLACK);					

					for(indice=0; indice<4; indice++) PrintV(85, 27+8*indice, info[index[indice]], 2);

					if(choix2>1){}


		
					if(choix2>1 && !choix3){
						PrintMini(80, 11+8*choix2, ">", 2);
						disp_Highlight(78, 10+8*choix2);
						PrintMini(80, 11+8*choix2, ">", 1);}
					else if(choix2>1){
						ML_bmp_xor(plusMoins, 86+4*loglol(info[index[choix2-2]]), 10+8*choix2, 5, 7);
						PrintMini(80, 11+8*choix2, "<", 2);
						ML_rectangle(84, 10+8*choix2, 84+4*loglol(info[index[choix2-2]]), 16+8*choix2, 0, ML_XOR, ML_XOR);
						ML_display_vram();	
						ML_rectangle(84, 10+8*choix2, 84+4*loglol(info[index[choix2-2]]), 16+8*choix2, 0, ML_XOR, ML_XOR);
						PrintMini(80, 11+8*choix2, "<", 2);
						ML_bmp_xor(plusMoins, 86+4*loglol(info[index[choix2-2]]), 10+8*choix2, 5, 7);}
					else if(choix2){
						ML_rectangle(3, 14, 35, 20, 0, ML_XOR, ML_XOR);
						ML_display_vram();
						ML_rectangle(3, 14, 35, 20, 0, ML_XOR, ML_XOR);}
					else{
						ML_rectangle(90, 14, 124, 20, 0, ML_XOR, ML_XOR);
						ML_display_vram();
						ML_rectangle(90, 14, 124, 20, 0, ML_XOR, ML_XOR);}


						
					key = getkey();
			
						
				}while(key!=0x0302 || choix2>1);
			
			
			if(!choix2){
				if(info[0]) info[0] = -1*info[0]*128;}

			}

			
		}while(key!=0x0302 || (choix1==4 && choix2));


		
		if(choix1){ // Si on ne revient pas au menu principal
			if(choix1==1){ info[1]=info[2]=9; info[3]=8; } // 12
			if(choix1==2){ info[1]=info[2]=17; info[3]=29; } // 44
			if(choix1==3){ info[1]=info[2]=23; info[3]=53; } // 96
		
			map = calloc(info[1]*info[2], 1);
			if(!map) return 0;

			ret = gamePlay(info, map);}} // _________________________ Lancement d'une nouvelle partie

	else{
		
		map = memory_load("\\\\fls0\\DeminrC\\map.sav");
		info = memory_load("\\\\fls0\\DeminrC\\info.sav");
		if(!map || !info) return 0;

		ret = gamePlay(info, map);} // _________________________ Lancement de la partie prcdente

	if(choix1){
		if(ret==-1 || ret==-2){
			memory_createdir("\\\\fls0\\DeminrC");
			memory_save("\\\\fls0\\DeminrC\\map.sav", map, info[1]*info[2]);
			memory_save("\\\\fls0\\DeminrC\\info.sav", info, 24);}
		else{
			memory_deletefile("\\\\fls0\\DeminrC\\map.sav");
			memory_deletefile("\\\\fls0\\DeminrC\\info.sav");}}


	
	free(map);	

/*
	
*/

	free(info);

	return ret;}



void credits(){

	float i;

	for(i=17; i>15; i-=0.06){
	
		ML_rectangle(0, 0, 127, 63, 0, ML_BLACK, ML_BLACK);

		PrintMini(41, 29, "DEMINEUR-C", 2);
		disp_Star(63, 31, 70, 47, i, i/13, ML_WHITE, 47);

		ML_display_vram();}


	for(i=0; i<8; i+=0.1){
	
		ML_rectangle(0, 0, 127, 63, 0, ML_BLACK, ML_BLACK);

		PrintMini(5, 5, "UN JEU DE", 2);
		PrintMini(5, 11, "PONTILEVIEN", 2);
		PrintMini(5, 17, "-2018-", 2);

		disp_Star(22, -5, 90, 37, 13, i/30, ML_WHITE, 37);

		ML_display_vram();}


	for(i=23; i<50; i++){
	
		ML_rectangle(0, 0, 127, 63, 0, ML_BLACK, ML_BLACK);

		PrintMini(56, 20, "AVEC", 2);
		PrintMini(31, 29, "MONOCHROMELIB.H", 2);
		PrintMini(40, 36, "DE PIERROTLL", 2);

		disp_Star(63, 31, 90, i, i*0.351351, 1.5708, ML_WHITE, i);

		ML_display_vram();

		Sleep(85);}

	ML_rectangle(0, 0, 127, 63, 0, ML_BLACK, ML_BLACK);
	
	PrintMini(5, 5, "USEFULL.H,", 2);
	PrintMini(5, 11, "DODORMEUR", 2);

	PrintMini(85, 48, "MEMORY.H,", 2);
	PrintMini(72, 54, "LEPHENIXNOIR", 2);

	for(i=0; i<13; i+=0.1){

		disp_Star(22, -5, 50, 13, 3, i/20, ML_WHITE, 37);
		disp_Star(105, 68, 57, 13, 3, -i/20, ML_WHITE, 37);

		ML_display_vram();}

	disp_Pontilev(45);}





#pragma section _BR_Size
unsigned long BR_Size;
#pragma section


int InitializeSystem(int isAppli, unsigned short OptionNum){
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);}

#pragma section

