#ifndef DISPLAY
#define DISPLAY

/*

Codage des case sur un octet :

Premier bit : case dcouverte (ou non)
Second bit : case contenant une bombe (ou non)
Troisime bit : case marque d'un drapeau (ou non)
Quatrime bit : case marque d'une hypothse (ou non)

Les quatres derniers bits codent, le cas chant, le nombre de bombes juxtaposes  la case (diagonales comprises)

Pour coder une case qui EXPLAOOSE (ciel !), vu que j'en avais marre et qu'il tait tard le soir, c'est juste 255.
Voil tout.

*/

#define CASE_DECOUVERTE 128
#define CASE_BOMBE 64
#define CASE_DRAPEAU 32
#define MASQUE_DRAPEAU 223
#define CASE_HYPOTHESE 16
#define MASQUE_HYPOTHESE 239

#define PI 3.14156

void disp_Case(int x, int y, unsigned char typeCase);	// Affiche aux coordonnes (x, y) sur l'cran la case de type typeCase

int loglol(int n); // Pas vraiment un loglol. Renvoie le nombre de caractres pour afficher n. Essentiel pour un peu de mise en page.

void disp_Time(int sec);	// Affiche dans le coin en-haut--gauche de l'cran la dure coule de la partie (en secondes)

void disp_Reste(int sec); // Le nombre de cases restant  dcouvrir dans le coin en-bas--gauche

void disp_Map(int* info, int x, int y, unsigned char* map);	// Affiche l'intgralit de la map, la case active au centre.

void anim_Boum(int* info, int x, int y, unsigned char* map); // Boum !

void disp_MsgFin(); // Affiche le cadre du msg

void disp_Tout(int* info, int x, int y, unsigned char* map, int t); // Affiche une frame complte

void disp_Time(int sec); // Affiche dans le coin en-haut--gauche de l'cran la dure coule de la partie (en secondes)

void disp_Highlight(int x, int y); // a, c'est pour les menus.

void disp_Pontilev(unsigned int d);

void disp_Star(int x, int y, int d, int n, float s, float a, int c, int e);
/*

x et y : coordonnes du centre
d : diamtre (le plus extrieur)
n : nombre de branches
s : niveau de "pointitude" des branches (grosso merdo)
a : angle d'inclinaison
c : couleur de dessin (ML)
e : nombre de branches  dessiner (possibilit de faire des toiles incompltes)

NB : tout se fait en radian

*/


#endif