#include "gameplay.h"
#include "stdlib.h"
#include "display.h"
#include "usefull.h"
#include "fxlib.h"
#include "MonochromeLib.h"






int _START_ = 0;	// C'est la seule variable globale de tout le code source ( cause de timer). Heure du dbut de loglollol partie
int _LIMITE_;  // Ahem... Plus maintenant.

int _NOTIMER_ = 0; // Permet un dialogue entre timer() et disp_Tout : si on est dja en train de faire un affichage, pas besoin de le refaire dans timer.
// Ce dialogue permet d'viter de courts glitchs pas trs esthtiques.

int* globINFO;
char* globMAP;

int globX;
int globY; // Voil la raison pour laquelle les timers c'est l'enfer ^^ VARIABLES GLOBALES DE PARTOUT !!!








int gamePlay(int* info, unsigned char* map){


	unsigned int key;
	unsigned int x = info[2]/2; // On initialise x et y pour tre au milieu de la map
	unsigned int y = info[1]/2;

	
	unsigned char* etats = NULL; // Servira  la propagation du dcouvrement d'une zone sans mine
	int wetats = info[2]/8;

	int ret = 0;


	if(info[0] < 0) _LIMITE_ = 1;
	else _LIMITE_ = 0;


	if(info[2]%8) wetats++;

	etats = calloc(wetats*info[1], 1);
	if(!etats) return 0;

	
	if(!info[5]){
		info[4] = info[1]*info[2] - info[3]; // Quand il n'y a plus de case  dcouvrir, c'est gagn
		srand(time_getTicks());
		genMap(info, map);
		info[5]=1;}

	_START_ = time_getTicks() - info[0];
	SetTimer(1, 1000, timer); // Le petit timer de l'AMOUR

	globINFO = info;
	globMAP = map;


	do{
		disp_Tout(info, x, y, map, time_getTicks()-_START_);

		globX = x;
		globY = y;

		key = getkey();

		if(_LIMITE_==2){
			ret = -5;
			key = 0;}

		switch(key){

			// case 0x0209  0308 : dplacement

			case 0x0209:
				if(y) y--;
				break;

			case 0x0309:
				if(x) x--;
				break;

			case 0x0208:
				if(x<info[2]-1) x++;
				break;

			case 0x0308:
				if(y<info[1]-1) y++;
				break;

			case 0x0708: // Dcouverte d'une case et consquences

				if(!(map[x+info[2]*y] & (CASE_DRAPEAU | CASE_DECOUVERTE))){
					setEtatOn(etats, wetats, x, y);
					info[4] -= fill(info, map, etats, wetats);

					if(map[x+info[2]*y] & CASE_BOMBE) ret = -3; // Voici le cas o on perd
					else if(!info[4]) ret = -4; // Et a, celui o on gagne

					disp_Tout(info, x, y, map, time_getTicks()-_START_);}

				break;

			case 0x0709:

				if(map[x+info[2]*y] & CASE_DRAPEAU){		// Drapeau -> Hypothse
					map[x+info[2]*y] &= MASQUE_DRAPEAU;
					map[x+info[2]*y] |= CASE_HYPOTHESE;}

				else if(map[x+info[2]*y] & CASE_HYPOTHESE){ // Hypothse -> Rien
					map[x+info[2]*y] &= MASQUE_HYPOTHESE;}

				else map[x+info[2]*y] |= CASE_DRAPEAU; // Rien -> Drapeau

				break;

			case 0x0408: // Exit (sortie immdiate du programme)
				ret = -1;
				break;

			case 0x0409: // Retour menu du programme
				ret = -2;
				break;}

	}while(!ret);

	KillTimer(1);
	
	free(etats);

	info[0] = time_getTicks() - _START_;

	if(ret==-3){
		anim_Boum(info, x, y, map);
		disp_Tout(info, x, y, map, info[0]);}

	if(ret==-3 || ret==-4){
		disp_MsgFin();

		if(ret==-3) PrintXY(25, 28, "C'est perdu !", 1);
		else PrintXY(25, 28, "C'est gagne !", 1); // Diantres de fonctions de fxlib.h qui n'acceptent pas les accents >_<

		ML_display_vram();

		getkey();}
	
	if(ret==-5) ret = -3;

	return ret;}








void timer(){
	
	if(_LIMITE_ && time_getTicks()-_START_>0){

		_LIMITE_ = 2;
		disp_MsgFin();
		PrintXY(25, 28, "C'est perdu !", 1);
		ML_display_vram();}

	else if(!_NOTIMER_) disp_Tout(globINFO, globX, globY, globMAP, time_getTicks()-_START_);}









void genMap(const int* info, unsigned char* map){

	int x, y, i, j, n;

	// Placement des n bombes et des nombres  afficher (= nombre de bombes dans les cases juxtaposes)
	// Et, oui. C'est moche. Tant de fors et do{}whiles insrs les uns dans les autres...
	// Mais c'est pas pire que etape(); ^^

	for(n = info[3]; n>0; n--){
		do{
			i = 0;
			x = alea(info[2]);
			y = alea(info[1]);
			if(!map[x+info[2]*y]){
				map[x+info[2]*y] = CASE_BOMBE;
				for(i=-1; i<2; i++){
					for(j=-1; j<2; j++){
						if(x+i>-1 && x+i<info[2] && y+j>-1 && y+j<info[1]) map[x+i+(y+j)*info[2]]++;}}}
		}while(!i);}}


int alea(int max){
	return rand() % max;}


int fill(int* info, unsigned char* map, unsigned char* etats, int wetats){
	
	int nTot = 0;
	int x, y, n;
	
	do{

		n = 0;

		for(x=0; x<info[2]; x++){
			for(y=0; y<info[1]; y++){
				if(getEtat(etats, wetats, x, y)){
					n += etape(info, x, y, map, etats, wetats);}}}
	
		nTot += n;
	
	}while(n);
	
	return nTot;}



int etape(int* info, int x, int y, unsigned char* map, unsigned char* etats, int wetats){
	
	int i, j, n;
	n=0;

	if(!(map[y*info[2]+x]%16) && !(map[y*info[2]+x] & CASE_BOMBE)){
		for(i=x-1; i<x+2; i++){
			if(i>=0 && i<info[2]){
				for(j=y-1; j<y+2; j++){
					if(j>=0 && j<info[1] && !(map[j*info[2]+i] & CASE_DECOUVERTE)){
							if(!map[j*info[2]+i]%16) setEtatOn(etats, wetats, i, j);
							map[j*info[2]+i] |= CASE_DECOUVERTE;
							n++;}}}}}
	else{
		map[y*info[2]+x] |= CASE_DECOUVERTE;
		n=1;}

	setEtatOff(etats, wetats, x, y);

	return n;}


unsigned char getEtat(unsigned char* etats, int wetats, int x, int y){
	static const unsigned char grosBits[8] = {1, 2, 4, 8, 16, 32, 64, 128};
	return (etats[y*wetats + x/8] & grosBits[x%8]);}

void setEtatOn(unsigned char* etats, int wetats, int x, int y){
	static const unsigned char grosBits[8] = {1, 2, 4, 8, 16, 32, 64, 128};
	etats[y*wetats + x/8] |= grosBits[x%8];}

void setEtatOff(unsigned char* etats, int wetats, int x, int y){
	static const unsigned char grosBits[8] = {254, 253, 251, 247, 239, 223, 191, 127};
	etats[y*wetats + x/8] &= grosBits[x%8];}









